<?php

@header('Content-type: text/html;charset=UTF-8');

$appid = "";  #需替换成你的appID 
$appsecret = "";  #需替换成你的appsecret  
$code = $_GET['code']; #微信返回的code

#获取openid和access_token
$url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid=$appid&secret=$appsecret&code=$code&grant_type=authorization_code"; 
$result = Utils::https_request($url);
$array = json_decode($result, true);
$access_token  = $array['access_token'];
$openid = $array['openid'];

#获取用户基本信息
$url = "https://api.weixin.qq.com/sns/userinfo?access_token=$access_token&openid=$openid&lang=zh_CN";  
$result = Utils::https_request($url); 
$array = json_decode($result, true);
$nickname = $array['nickname']; #用户昵称
$headimgurl = $array['headimgurl']; #用户头像

class Utils{

	public static function https_request($url, $data = null){  
		$curl = curl_init();  
		curl_setopt($curl, CURLOPT_URL, $url);  
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);  
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);  
		if (!empty($data)){  
			curl_setopt($curl, CURLOPT_POST, 1);  
			curl_setopt($curl, CURLOPT_POSTFIELDS, $data);  
		}  
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);  
		$output = curl_exec($curl);  
		curl_close($curl);  
		return $output;  
	}

	/** 
     * 获取access_token方法
     * @return mixed 
     */  
    public static function get_access_token(){
		$appid = ""; //需替换成你的appID 
		$appsecret = ""; //需替换成你的appsecret  
		$url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=$appid&secret=$appsecret";  
		$output = Utils::https_request($url);  
		$jsoninfo = json_decode($output, true);
		$access_token = $jsoninfo["access_token"]; 
		return $access_token;
    }

}

?>